<i18n lang="yml">
en:
  last_scan: "Time"
  quarter: "Quarter"
  area: "Area"
  district: "District"
  cluster_location: "Container address"
  location_type: "ABP location type"
  freq_per_week: "Frequency per week"
  item_cardboard: "Paper"
  item_bags: "Bags"
  item_bulky: "Bulky"
  item_sia: "SIA"
  urgency: "Urgency"
nl:
  last_scan: "Tijdstip"
  quarter: "Wijk"
  area: "Gebied"
  district: "Stadsdeel"
  cluster_location: "Container adres"
  location_type: "ABP-locatietype"
  freq_per_week: "Frequentie per week"
  item_cardboard: "Karton"
  item_bags: "Huisvuil"
  item_bulky: "Grof"
  item_sia: "SIA"
  urgency: "Urgentie"
</i18n>

<template>
  <AmsTableGroup tag="thead">
    <template v-for="(row, rIndex) of rows">
      <AmsTableRow
        :key="rIndex"
        :class="foldoutState.openedFilters ? $style['filters-row-open'] : null"
      >
        <!-- First contentless cell in row -->
        <AmsTableCell
          v-if="foldableRows"
          tag="th"
          style="width: 2rem;"
        />

        <!-- Content cells -->
        <template v-for="(cell, cIndex) in row">
          <AmsTableCell
            v-show="!cell.isHidden"
            :key="cIndex"
            :ref="cell.id"
            tag="th"
            scope="col"
            :class="[
              $style['table-header-cell'],
              $style[cell.id],
              cell.sortable ? $style['is-clickable'] : null,
              formattedCells[cell.id].hideable ? 'opacity-0 x2l:table-cell x2l:opacity-1' : null,
            ]"
            :style="formattedCells[cell.id].hideable ? 'padding: 0px; width: 0px;' : null"
            @click.native="onClickSort(cell.sortable, cell.id, $event)"
          >
            <div :class="$style['content']">
              {{ $t(cell.id) }}

              <span
                v-if="cell.sortable"
                :class="[
                  $style['icon'],
                  $style['icon-sort'],
                  $style[`is-sorted-${sortState.sortDirs[cell.id]}`],
                  sortState.currentSort !== cell.id ? $style['is-inactive'] : null,
                ]"
              >
                <SvgArrowheadDown />
              </span>
            </div>
          </AmsTableCell>
        </template>
      </AmsTableRow>

      <!-- Collapsible rows with additional information on the row above it -->
      <template v-if="foldableRows">
        <transition :key="`${rIndex}x`" name="zap-h">
          <AmsScansTableRowFoldout
            v-if="foldoutState.openedFilters"
            :show-filters="true"
            :cells="formattedCells"
            :hide-columns="enableViewOptions && STATE.rightPanelOpen"
            :class="foldoutState.openedFilters ? $style['filters-row-open'] : null"
          />
        </transition>
      </template>
    </template>
  </AmsTableGroup>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  inject,
} from "@nuxtjs/composition-api";

import cloneDeep from "lodash/fp/cloneDeep";

import useRowFoldout from "~/composables/row-foldout";
import useSorting from "~/composables/sorting";

export default defineComponent({
  name: "AmsScansTable",

  components: {
    AmsTableGroup: () => import("~/components/_elements/Table/TableGroup.vue"),
    AmsTableRow: () => import("~/components/_elements/Table/TableRow.vue"),
    AmsTableCell: () => import("~/components/_elements/Table/TableCell.vue"),
    AmsScansTableRowFoldout: () => import("./ScansTableRowFoldout.vue"),

    SvgArrowheadDown: () => import("~/assets/img/ui/arrowhead-down.svg"),
  },

  props: {
    rows: {
      type: Array,
      default: () => [],
    },
    tGIndex: {
      type: Number,
      required: true,
    },
    foldableRows: {
      type: Boolean,
      default: false,
    },
    enableViewOptions: {
      type: Boolean,
      required: true,
    },
    openFiltersRow: {
      type: Boolean,
      default: false,
    },
  },

  setup (props) {
    const { STATE } = inject("store");
    const { foldoutState } = useRowFoldout();
    const { sortState, sort } = useSorting();

    const formattedCells = computed(() => {
      const cells = cloneDeep(props.rows[0]);
      const hideConditionally = props.enableViewOptions && STATE.rightPanelOpen;

      // @ts-ignore
      Object.values(cells).forEach((cell) => {
        cell.hideable = hideConditionally && cell.hideable;
      });

      return cells;
    });

    function onClickSort (isSortable: boolean, cellId: string) {
      if (isSortable) {
        sort(cellId);
      }
    }

    return {
      STATE,
      sortState,
      foldoutState,
      formattedCells,
      onClickSort,
    };
  },
});
</script>

<style lang="postcss" module>
tr {
  @apply rounded-sm;

  &.filters-row-open {
    @apply bg-gray-150;

    td {
      @apply bg-gray-150;
    }
  }
}

.table-header-cell {
  transition:
    width 250ms ease,
    opacity 250ms ease,
  ;

  &.is-clickable {
    &:hover,
    &[data-focus-visible-added] {
      @apply bg-gray-200 text-gray-700 cursor-pointer;
    }
  }

  &.last_scan {
    width: 85px;
  }

  &.cluster_location {
    width: 100%;
    min-width: 180px;

    & > div {
      width: 180px;
    }
  }

  &.area,
  &.quarter,
  &.location_type {
    width: 150px;
  }

  &.item_cardboard,
  &.item_bags,
  &.item_bulky {
    width: 75px;
  }

  &.urgency {
    width: 120px;
  }
}

th:first-of-type {
  @apply rounded-l-sm;
}

th:last-of-type {
  @apply rounded-r-sm;
}

.content {
  @apply flex h-6 overflow-hidden;
}

.icon {
  transition: transform 250ms ease;

  @apply flex justify-center items-center text-gray-700;

  svg {
    width: 14px;
    height: 14px;
  }
}

.icon-sort {
  @apply inline-flex ml-1;

  &.is-inactive {
    @apply text-gray-400;
  }

  &.is-sorted-asc {
    transform: rotate(180deg);
  }

  &.is-sorted-desc {
    transform: rotate(0deg);
  }
}
</style>
